.586    
.model flat,stdcall
option casemap:none

WinMain PROTO   :DWORD,:DWORD,:DWORD,:DWORD

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\comctl32.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\comctl32.lib

.const

MainWindowWidth     equ     600
MainWindowHeight    equ     350

.data

hInstance       dd      ?
hMainWindow     dd      ?
MainWindowClass db      'MainWindowClass',0
MainWindowName  db      'Animation Control',0

wc          WNDCLASSEX  <sizeof wc,CS_HREDRAW+CS_VREDRAW,offset WndProc,NULL,NULL,NULL, \
                        NULL,NULL,COLOR_WINDOW,NULL,offset MainWindowClass,NULL>

; ++++ Animation Control +++++
AnimateClass    db      'SysAnimate32',0
hAnimate        dd          ?

; ++++ Toolbar related +++++

ToolbarClass    db      'ToolbarWindow32',0
hToolbar        dd          ?
TBButtons       TBBUTTON    <0,0,TBSTATE_ENABLED,TBSTYLE_BUTTON,NULL,NULL>
                TBBUTTON    <0,1,TBSTATE_ENABLED,TBSTYLE_BUTTON,NULL,NULL>
                TBBUTTON    <0,2,TBSTATE_ENABLED,TBSTYLE_BUTTON,NULL,NULL>
                TBBUTTON    <0,0,TBSTATE_ENABLED,TBSTYLE_SEP,NULL,NULL>
                TBBUTTON    <0,3,TBSTATE_ENABLED,TBSTYLE_BUTTON,NULL,NULL>
rect        RECT            <>
szDex       db      'D:\downloads\Dexter Season 3\Dexter.S03E05.HDTV.XviD-0TV.avi',0
szEnc       db      "D:\downloads\Encarnao do Demonio\Encarnacao.do.Demonio.avi",0
szBear      db      'C:\Users\luis\Videos\Movie.avi',0

iccx        INITCOMMONCONTROLSEX    <sizeof iccx,ICC_BAR_CLASSES+ICC_ANIMATE_CLASS+ICC_STANDARD_CLASSES>

.code
    start:
        invoke  GetModuleHandle,NULL
        mov hInstance,eax
        invoke  WinMain,hInstance,NULL,NULL,SW_SHOWNORMAL
        invoke  ExitProcess,eax

WinMain PROC    hInst:DWORD,hPInst:DWORD,CmdLine:DWORD,CmdShow:DWORD

    local   msg:MSG

    push    hInstance
    pop     wc.hInstance
    invoke  LoadIcon,NULL,IDI_APPLICATION
    mov     wc.hIcon,eax
    mov     wc.hIconSm,eax
    invoke  LoadCursor,NULL,IDC_ARROW
    mov     wc.hCursor,eax
    invoke  RegisterClassEx,addr wc
    invoke  GetSystemMetrics,SM_CYSCREEN
    shr     eax,1
    sub     eax,MainWindowHeight/2
    push    eax
    invoke  GetSystemMetrics,SM_CXSCREEN
    shr     eax,1
    sub     eax,MainWindowWidth/2
    pop     ebx
    invoke  CreateWindowEx,NULL,addr MainWindowClass,addr MainWindowName,WS_TILEDWINDOW+WS_CLIPCHILDREN+WS_CLIPSIBLINGS,\   
               eax,ebx,MainWindowWidth,MainWindowHeight,NULL,NULL,hInstance,NULL
    mov     hMainWindow,eax
    invoke  ShowWindow,eax,CmdShow
    invoke  UpdateWindow,hMainWindow

msg_loop:
    invoke  GetMessage,addr msg,NULL,0,0
    or      eax,eax
    jz      end_msg_loop
    invoke  TranslateMessage,addr msg
    invoke  DispatchMessage,addr msg
    jmp     msg_loop
end_msg_loop:
    mov     eax,msg.wParam
    ret

WinMain     endp

WndProc PROC    hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    .if uMsg==WM_DESTROY
        invoke  PostQuitMessage,NULL
    .elseif uMsg==WM_CREATE
        mov edi,lParam
        .if [edi.CREATESTRUCT].hWndParent==NULL
            invoke  InitCommonControlsEx,addr iccx
            invoke  CreateWindowEx,NULL,addr ToolbarClass,NULL,WS_VISIBLE+WS_CHILD+TBSTYLE_ALTDRAG,\
                        0,0,0,0,hWnd,NULL,hInstance,NULL
            mov     hToolbar,eax
            invoke  SendMessage,hToolbar,TB_BUTTONSTRUCTSIZE,sizeof TBBUTTON,NULL
            invoke  SendMessage,hToolbar,TB_ADDBUTTONS,5,addr TBButtons
            invoke  SendMessage,hToolbar,TB_AUTOSIZE,NULL,NULL                        
            invoke  GetClientRect,hWnd,addr rect
            invoke  SendMessage,hToolbar,TB_GETBUTTONSIZE,NULL,NULL
            add     eax,6
            sub     rect.bottom,eax
            add     rect.top,eax
            invoke  CreateWindowEx,WS_EX_CLIENTEDGE,addr AnimateClass,NULL,WS_VISIBLE+WS_CHILD+ACS_AUTOPLAY+ACS_CENTER+ACS_TRANSPARENT,\
                                NULL,NULL,NULL,NULL,hWnd,0100h,hInstance,NULL
            mov hAnimate,eax
            invoke  SendMessage,hAnimate,ACM_OPEN,NULL,addr szBear
            invoke  SendMessage,hAnimate,ACM_PLAY,1,200
        .endif 
    .elseif     uMsg==WM_SIZE
        mov eax,lParam
        movzx   ebx,ax
        shr eax,16
        invoke  MoveWindow,hAnimate,0,30,ebx,eax,TRUE 

    .elseif uMsg==WM_COMMAND
        mov eax,wParam
        .if ax==0
            invoke  SendMessage,hAnimate,ACM_OPEN,NULL,addr szBear
            or  eax,eax
            jnz play_it
            invoke  Beep,200,1
            jmp abort
play_it:            
            invoke  SendMessage,hAnimate,ACM_PLAY,1,-1
abort:            
        .endif                                                               
    .else
        invoke  DefWindowProc,hWnd,uMsg,wParam,lParam
        ret
    .endif
    xor eax,eax
    ret

WndProc     endp

end start                                            
